DPDK patches and discussions
 help / color / mirror / Atom feed
From: Thomas Monjalon <thomas@monjalon.net>
To: dev@dpdk.org
Cc: stable@dpdk.org, Bruce Richardson <bruce.richardson@intel.com>,
	David Marchand <david.marchand@redhat.com>
Subject: [PATCH] devtools: move mailmap check after patch applied
Date: Mon, 27 Mar 2023 16:52:19 +0200	[thread overview]
Message-ID: <20230327145219.1927159-1-thomas@monjalon.net> (raw)

The names in a patch were possibly checked with checkpatches.sh
before applying the patch, so before .mailmap file was updated.

The check is moved and translated in check-git-log.sh,
which is run only on a repository, not a detached patch file.

Fixes: e83d41f0694d ("mailmap: add list of contributors")
Cc: stable@dpdk.org

Signed-off-by: Thomas Monjalon <thomas@monjalon.net>
---
 devtools/check-git-log.sh | 15 +++++++++++++++
 devtools/checkpatches.sh  | 30 ------------------------------
 2 files changed, 15 insertions(+), 30 deletions(-)

diff --git a/devtools/check-git-log.sh b/devtools/check-git-log.sh
index e26205814b..af751e49ab 100755
--- a/devtools/check-git-log.sh
+++ b/devtools/check-git-log.sh
@@ -259,6 +259,21 @@ done)
 [ -z "$bad" ] || { printf "Missing 'Signed-off-by:' tag: \n$bad\n"\
 	&& failure=true;}
 
+# check names
+names=$(git log --format='From: %an <%ae>%n%b' --reverse $range |
+	sed -rn 's,.*: (.*<.*@.*>),\1,p' |
+	sort -u)
+bad=$(for contributor in $names ; do
+	! grep -qE "^$contributor($| <)" $selfdir/../.mailmap || continue
+	if grep -q "^${contributor%% <*} <" .mailmap ; then
+		printf "\t$contributor is not the primary email address\n"
+	else
+		printf "\t$contributor is unknown in .mailmap\n"
+	fi
+done)
+[ -z "$bad" ] || { printf "Contributor name/email mismatch with .mailmap: \n$bad\n"\
+	&& failure=true;}
+
 total=$(echo "$commits" | wc -l)
 if $failure ; then
 	printf "\nInvalid patch(es) found - checked $total patch"
diff --git a/devtools/checkpatches.sh b/devtools/checkpatches.sh
index 1dee094c7a..a07bbc83cb 100755
--- a/devtools/checkpatches.sh
+++ b/devtools/checkpatches.sh
@@ -248,28 +248,6 @@ check_release_notes() { # <patch>
 		grep -v $current_rel_notes
 }
 
-check_names() { # <patch>
-	res=0
-
-	old_IFS=$IFS
-	IFS='
-'
-	for contributor in $(sed -rn '/^$/,/^--- / {s/.*: (.*<.*@.*>)/\1/p}' $1); do
-		! grep -qE "^$contributor($| <)" .mailmap || continue
-		name=${contributor%% <*}
-		if grep -q "^$name <" .mailmap; then
-			reason="$name mail differs from primary mail"
-		else
-			reason="$contributor is unknown"
-		fi
-		echo "$reason, please fix the commit message or update .mailmap."
-		res=1
-	done
-	IFS=$old_IFS
-
-	return $res
-}
-
 number=0
 range='origin/main..'
 quiet=false
@@ -378,14 +356,6 @@ check () { # <patch-file> <commit>
 		ret=1
 	fi
 
-	! $verbose || printf '\nChecking names in commit log:\n'
-	report=$(check_names "$tmpinput")
-	if [ $? -ne 0 ] ; then
-		$headline_printed || print_headline "$subject"
-		printf '%s\n' "$report"
-		ret=1
-	fi
-
 	if [ "$tmpinput" != "$1" ]; then
 		rm -f "$tmpinput"
 		trap - INT
-- 
2.39.1


             reply	other threads:[~2023-03-27 14:52 UTC|newest]

Thread overview: 4+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2023-03-27 14:52 Thomas Monjalon [this message]
2023-03-28 13:52 ` David Marchand
2023-03-28 14:27   ` Ferruh Yigit
2023-03-28 17:11     ` Thomas Monjalon

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20230327145219.1927159-1-thomas@monjalon.net \
    --to=thomas@monjalon.net \
    --cc=bruce.richardson@intel.com \
    --cc=david.marchand@redhat.com \
    --cc=dev@dpdk.org \
    --cc=stable@dpdk.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).